--[[
  Name: Recount FailBot Module
  Heavily based on: Ideas and code posted by sylvanaar
  Author: Elsia
]]

if not Recount then return end --  Forget about this if no Recount is present

local Recount = Recount

local RecountFailBot = LibStub("AceAddon-3.0"):NewAddon("RecountFailBot")
RecountFailBot.Version = tonumber(string.sub("$Revision: 21 $", 12, -3))

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountFailBot")

local fail = LibStub("LibFail-1.0")
local fail_events = fail:GetSupportedEvents()

local DetailTitles={}
DetailTitles.FailedHow={
	TopNames = RL["Ability Name"],
	TopCount = "",
	TopAmount = RL["Count"],
	BotNames = "",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = RL["Count"]
}

local Epsilon=0.000000000000000001

--local verboseFailString = 
--{
--	["Fail_Sartharion_LavaWaves"] = L["Sartharion's Lava Wave"],
--	["Fail_Heigan_Dance"] = L["Heigan's Dance"],
--	["Fail_Sartharion_VoidZone"] = L["Sartharion's Void Zone"],
--	["Fail_KelThuzad_VoidZone"] = L["Kel'Thuzad's Void Zone"],
--	["Fail_Sapphiron_Breath"] = L["Sapphiron's Breath"],
--	["Fail_Frogger"] = L["Naxxramas Frogger"],
--	["Fail_Thaddius_PolaritySwitch"] = L["Thaddius Polarity Switch"],
--	["Fail_Thaddius_Jump"] = L["Jump to Thaddius"], 
--	["Fail_Deconstructor_Light"] = L["Deconstructor Light"],
--    ["Fail_Deconstructor_Void"] = L["Deconstructor Void"],
--    ["Fail_Mimiron_Rocket"] = L["Mimiron Rocket"],
--    ["Fail_Thorim_LightningCharge"] = L["Thorim Lightning Charge"],
--    ["Fail_Thorim_LightningChain"] = L["Thorim Lightning Chain"],
--    ["Fail_Thorim_Smash"] = L["Thorim Smash"],
--    ["Fail_Vezax_ShadowCrash"] = L["Vezax Shadow Crash"],
--    ["Fail_Mimiron_Shock"] = L["Mimiron Shock"],
--    ["Fail_Mimiron_BombBots"] = L["Mimiron Bomb Bots"],
--    ["Fail_Vezax_Saronite"] = L["Vezax Saronite"], -- Patch for localization
--    ["Fail_Vezax_Leech"] = L["Vezax Leech"],
--    ["Fail_Hodir_FlashFreeze"] = L["Hodir Flash Freeze"],
--    ["Fail_Mimiron_LaserBarrage"] = L["Mimiron Laser Barrage"],
--    ["Fail_Mimiron_Flames"] = L["Mimiron Flames"],
--    ["Fail_Council_Overload"] = L["Council Overload"],
--    ["Fail_Hodir_Icicle"] = L["Hodir Icicle"],
--    ["Fail_Freya_Sunbeam"] = L["Freya Sunbeam"],
--    ["Fail_Freya_NatureBomb"] = L["Freya Nature Bomb"],
--    ["Fail_Thorim_Blizzard"] = L["Thorim Blizzard"],
--    ["Fail_Yogg_Sanity"] = L["Yogg Sanity"],
--    ["Fail_Yogg_DeathRay"] = L["Yogg Death Ray"],
--    ["Fail_Racorscale_Flame"] = L["Razorscale Flame"],
--    ["Fail_Kologarn_Eyebeam"] = L["Kologarn Eyebeam"],
--    ["Fail_Auriaya_Voidzone"] = L["Auriaya Voidzone"],
--    ["Fail_Hodir_BitingCold"] = L["Hodir Biting Cold"],
--	["Fail_Malygos_Dot"] = L["Malygos Dot Drop"],
--}


function RecountFailBot:OnEnable()
end

function RecountFailBot:OnDisable()
end

-- Stolen straight from Sylvannars skeleton, don't use fatal but oh well
local function onFail(event, who, fatal)
	if not Recount.db2.combatants[who] then
		Recount:DPrint("No source combatant!")
	else
		local sourceData=Recount.db2.combatants[who]
		local sourceName = sourceData.Name
		Recount:AddAmount(sourceData,"Fails",1)
		local spell = GetSpellInfo(fail:GetEventSpellId(event)) or ""
		Recount:AddTableDataStats(sourceData,"FailedHow",spell,sourceName,1)
--		Recount:AddTableDataStats(sourceData,"FailedHow",verboseFailString[event],sourceName,1)
	end
end

for _, event in ipairs(fail_events) do
	fail:RegisterCallback(event, onFail)
end

function RecountFailBot:DataModesFailBot(data, num)
	if not data then return 0 end
	if num==1 then
		return (data.Fights[Recount.db.profile.CurDataSet].Fails or 0)
	else
		return (data.Fights[Recount.db.profile.CurDataSet].Fails or 0), {{data.Fights[Recount.db.profile.CurDataSet].FailedHow,L["'s Fail Events"],DetailTitles.FailedHow}}
	end
end

function RecountFailBot:TooltipFuncsFailBot(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData(RL["Top 3"].." "..L["Fails"],data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].FailedHow,3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end



Recount:AddModeTooltip(L["Fails"],RecountFailBot.DataModesFailBot,RecountFailBot.TooltipFuncsFailBot,nil,nil,nil,nil)
